package techreborn.client.gui.autocrafting;

import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.GuiButtonImage;
import net.minecraft.client.renderer.RenderHelper;
import net.minecraft.client.renderer.RenderItem;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.inventory.ClickType;
import net.minecraft.inventory.Container;
import net.minecraft.inventory.InventoryCrafting;
import net.minecraft.inventory.Slot;
import net.minecraft.item.ItemStack;
import net.minecraft.item.crafting.IRecipe;
import org.lwjgl.opengl.GL11;
import reborncore.common.network.NetworkManager;
import techreborn.client.gui.GuiBase;
import techreborn.packets.PacketSetRecipe;
import techreborn.tiles.TileAutoCraftingTable;

import java.io.IOException;

import static net.minecraft.item.ItemStack.EMPTY;

/**
 * Created by modmuss50 on 20/06/2017.
 */
public class GuiAutoCrafting extends GuiBase {

	GuiAutoCraftingRecipeSlector recipeSlector = new GuiAutoCraftingRecipeSlector();
	private GuiButtonImage recipeButton;
	boolean showGui = true;
	InventoryCrafting dummyInv;
	TileAutoCraftingTable tileAutoCraftingTable;

	public GuiAutoCrafting(EntityPlayer player, TileAutoCraftingTable tile) {
		super(player, tile, tile.createContainer(player));
		this.tileAutoCraftingTable = tile;
	}

	@Override
	public void func_73876_c() {
		super.func_73876_c();
		recipeSlector.func_193957_d();
	}

	public void renderItemStack(ItemStack stack, int x, int y) {
		if (stack != field_190927_a) {
			GL11.glEnable(GL11.GL_BLEND);
			GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
			RenderHelper.func_74520_c();

			RenderItem itemRenderer = Minecraft.func_71410_x().func_175599_af();
			itemRenderer.func_180450_b(stack, x, y);

			GL11.glDisable(GL11.GL_LIGHTING);
		}
	}

	@Override
	protected void func_146979_b(int mouseX, int mouseY) {
		super.func_146979_b(mouseX, mouseY);
		IRecipe recipe = tileAutoCraftingTable.getIRecipe();
		if(recipe != null){
			renderItemStack(recipe.func_77571_b(), 10, 25);
		}
	}

	@Override
	public void func_73866_w_() {
		super.func_73866_w_();
		recipeSlector.setGuiAutoCrafting(this);
		dummyInv = new InventoryCrafting(new Container() {
			@Override
			public boolean func_75145_c(EntityPlayer playerIn) {
				return false;
			}
		}, 3, 3);
		for (int i = 0; i < 9; i++) {
			dummyInv.func_70299_a(i, ItemStack.field_190927_a);
		}
		this.recipeSlector.func_191856_a(this.field_146294_l, this.field_146295_m, this.field_146297_k, false, this.field_147002_h, dummyInv);
		this.field_147003_i = this.recipeSlector.func_193011_a(false, this.field_146294_l, this.xSize);
	}

	@Override
	public void func_73863_a(int mouseX, int mouseY, float partialTicks) {
		if (showGui) {
			this.recipeSlector.func_191861_a(mouseX, mouseY, 0.1F);
			super.func_73863_a(mouseX, mouseY, partialTicks);
			this.recipeSlector.func_191864_a(this.field_147003_i, this.field_147009_r, false, partialTicks);
		} else {
			super.func_73863_a(mouseX, mouseY, partialTicks);
		}
		this.recipeSlector.func_191876_c(this.field_147003_i, this.field_147009_r, mouseX, mouseY);
	}

	@Override
	protected void func_73864_a(int mouseX, int mouseY, int mouseButton) throws IOException {
		if (!this.recipeSlector.func_191862_a(mouseX, mouseY, mouseButton)) {
			if (!showGui || !this.recipeSlector.func_191878_b()) {
				super.func_73864_a(mouseX, mouseY, mouseButton);
			}
		}
	}

	@Override
	protected void func_73869_a(char typedChar, int keyCode) throws IOException {
		if (!this.recipeSlector.func_191859_a(typedChar, keyCode)) {
			super.func_73869_a(typedChar, keyCode);
		}
	}

	@Override
	protected void func_184098_a(Slot slotIn, int slotId, int mouseButton, ClickType type) {
		super.func_184098_a(slotIn, slotId, mouseButton, type);
		this.recipeSlector.func_191874_a(slotIn);
	}

	public void func_146281_b() {
		this.recipeSlector.func_191871_c();
		super.func_146281_b();
	}

	public void setRecipe(IRecipe recipe){
		tileAutoCraftingTable.setCurrentRecipe(recipe.getRegistryName());
		NetworkManager.sendToServer(new PacketSetRecipe(tileAutoCraftingTable, recipe.getRegistryName()));
	}


}
